﻿break

$file="c:\temp\o365-admin-noMfa.txt"

ConvertTo-SecureString -String (Read-Host -AsSecureString -Prompt "Enter your password") -AsPlainText -Force |ConvertFrom-SecureString |Add-Content -Path $file

$userName="admin@[mytenant].onmicrosoft.com"
$securePassword=$(Get-Content $File | ConvertTo-SecureString)

$MyAccount=New-Object -TypeName System.Management.Automation.PSCredential -ArgumentList $userName,$securePassword

$filename = "c:\temp\CliXml.txt"
$MyAccount=Get-Credential
$MyAccount | Export-CliXml -Path $filename

$xml=Import-Clixml -Path $filename
$xml.UserName
$xml.Password

$MyAccount=New-Object -TypeName System.Management.Automation.PSCredential `
 -ArgumentList $xml.UserName, $xml.Password 

<###############################################


            
            S4B



###############################################>

$Skype=New-CsOnlineSession -Credential $MyAccount
Import-PSSession $Skype
Get-CsOnlineUser | select name, proxyaddresses

Get-Module



Remove-PSSession $Skype
Get-Module

get-csonlin

<###############################################


            
            Exchange



###############################################>

$Exchange=New-PSSession -ConfigurationName Microsoft.Exchange -ConnectionUri "https://outlook.office365.com/powershell-liveid/" -Credential $MyAccount -Authentication "Basic" -AllowRedirection
$Exchange=New-PSSession -ConfigurationName Microsoft.Exchange -ConnectionUri "https://outlook.office365.com/powershell-liveid/" -Credential (Get-Credential) -Authentication "Basic" -AllowRedirection
Import-PSSession $Exchange
Get-Mailbox
Remove-PSSession $Exchange


#Exchange MFA
Connect-EXOPSSession -UserPrincipalName admin@mydomain.si

<###############################################


            
            Azure AD



###############################################>


Connect-MsolService -Credential $MyAccount
$MyAccount=Get-Credential

Get-Command -Module MSOnline

Get-Module -ListAvailable


Get-MsolUser -All -Department "Sales" -UsageLocation "SI" -UnlicensedUsersOnly;

Get-MsolAccountSku

Set-msoluser –userprincipalname admin@mydomain.si –usagelocation SI -AddLicenses "litwareinc:ENTERPRISEPACK"

(Get-Command -Noun "MSOL*").count

Connect-AzureAD -Credential $MyAccount

(Get-Command -Noun "AzureAD*").count

Set-AzureADUser -UserPrincipalName admin@mydomain.si -City Ljubljana -UsageLocation SI #no license

Set-AzureADUserLicense

<###############################################

        PnP
        GitHub - SharePoint/PnP-PowerShell: SharePoint / Office 365 Dev PnP PowerShell CmdLets
		https://github.com/SharePoint/PnP-PowerShell
		
		SharePoint Version	Command to install
		SharePoint Online	Install-Module SharePointPnPPowerShellOnline
		SharePoint 2016	Install-Module SharePointPnPPowerShell2016
		SharePoint 2013	Install-Module SharePointPnPPowerShell2013
        
###############################################>

#SharePoint Online	
Install-Module SharePointPnPPowerShellOnline

#Update
Update-Module SharePointPnPPowerShell*

(Get-Command -Noun "SPO*").count

#List all commands
(Get-Command -Module *PnP*).count

#Connect
Connect-PnPOnline -Url https://[mytenantUrl].sharepoint.com/sites/robi/ -UseWebLogin

Get-PnPSite
Get-PnPWeb
$web=Get-PnPWeb
Get-PnPList

#Disconnect-PnPOnline

#Create new site collection
$siteUrl="https://[mytenantUrl].sharepoint.com/sites/robi"
$owner="admin@mydomain.si"

Connect-PnPOnline $tenantUrl -Credentials $MyAccount

Write-Host "Provisioning site collection $siteUrl" -ForegroundColor Yellow
	
if(Get-PnPTenantSite | where {$_.Url -eq $siteUrl}) 
{
	Write-Host "Site collection $siteUrl exists. Moving to the next one." -ForegroundColor Yellow
	continue
}

# Creates new site collection.
New-PnPTenantSite -Owner $Owner -TimeZone 6 -Title "Slo SPUG demo SC" -Url $siteUrl -Template "STS#0" -Lcid 1060 -Wait

Connect-PnPOnline -Url $siteUrl -UseWebLogin
#Upload file to document library
Add-PnPFile -Path "c:\temp\Password.txt" -Folder "Shared Documents"



$items=Get-ChildItem -Path "c:\temp\" |?{$_.extension -ne ".ps1"}
foreach($item in $items){

    Add-PnPFile -Path $item.fullname -Folder "Shared Documents"

}


Connect-SPOService -URL https://Tenant-admin.sharepoint.com -Credential $MyAccount
Get-SPOSite
Get-Command -Module Microsoft.Online.SharePoint.PowerShell


(Get-Command -Noun "pnp*").count

Install-Module SharePointPnPPowerShellOnline
Get-Command -Module SharePointPnPPowerShellOnline

Get-Module SharePointPnPPowerShellOnline |fl


Connect-PnPOnline -Url https://[mytenantUrl].sharepoint.com -CreateDrive
cd SPO:\
cd SitePages

<###############################################


MS Teams
            


###############################################>





Install-Module MicrosoftTeams

Connect-MicrosoftTeams
Get-Command -Module MicrosoftTeams

Get-Team 
$team=(Get-Team)[2]

$team.

<###############################################


Password management
            


###############################################>




# Create-EncryptedCredentialFile 
#$credentials = Get-Credential 
$filename = "c:\temp\CliXml.txt"
$MyAccount
$MyAccount | Export-CliXml -Path $filename

$xml=Import-Clixml -Path $filename
$xml.UserName
$xml.Password

$MyAccount=New-Object -TypeName System.Management.Automation.PSCredential `
 -ArgumentList $xml.UserName, $xml.Password 



# Since we’re doing this remotely, we need to authenticate 
$temp = Get-Content C:\temp\secretfile.txt 
$securePassword = ConvertTo-SecureString -String $temp 
$credentials = New-Object System.Management.Automation.PSCredential ("contoso\johnsmith", $securePassword)


'Pa$$w0rd' | ConvertTo-SecureString -AsPlainText -Force | ConvertFrom-SecureString | Out-File "c:\temp\Password.txt"

$User = "MyUserName"
$File = "c:\temp\Password.txt"
$MyCredential=New-Object -TypeName System.Management.Automation.PSCredential `
 -ArgumentList $User, (Get-Content $File | ConvertTo-SecureString)



 <#


    Key file

 #>

$KeyFile = "c:\temp\Key.txt"
$Key = New-Object Byte[] 32   # You can use 16, 24, or 32 for AES
[Security.Cryptography.RNGCryptoServiceProvider]::Create().GetBytes($Key)
$Key | out-file $KeyFile

$PasswordFile = "c:\temp\Key-Password.txt"
$KeyFile = "c:\temp\Key.txt"
$Key = Get-Content $KeyFile
$Password = "P@ssword1" | ConvertTo-SecureString -AsPlainText -Force
$Password | ConvertFrom-SecureString -key $Key | Out-File $PasswordFile

#[Byte[]] $key = (1..16)


$User = "MyUserName"
$PasswordFile = "c:\temp\Key-Password.txt"
$KeyFile = "c:\temp\Key.txt"
$key = Get-Content $KeyFile
$MyCredential = New-Object -TypeName System.Management.Automation.PSCredential `
 -ArgumentList $User, (Get-Content $PasswordFile | ConvertTo-SecureString -Key $key)





 #################  Windows Credential Manager  ###############################

Install-Module -name credentialmanager

$managedCred = Get-StoredCredential -Target o365
New-StoredCredential -Credentials $MyAccount -Target NTK2018
Connect-msolService -Credential $MyAccount

$credMnager=Get-StoredCredential -Target NTK2018


New-StoredCredential -Target o365 -UserName test@contoso.com -Password 'Pa$$w0rd'

$cred=Get-StoredCredential -Target NTK2018

$cred=Get-StoredCredential -Target o365

Connect-MsolService -Credential $credMnager